#ifndef BLE_SCANNER_NEW_H_
#define BLE_SCANNER_NEW_H_

#define SUCCESS                         0
#define BT_GENERAL_ERROR               -1
#define BT_CONNECTED                    1
#define BT_DISCONNECTED                 2
#define BT_DEVICE_FOUND                 3
#define BT_READY                        5
#define BT_NEW_DATA                     6
#define BT_DEVICE_CONNECTED             7
#define BT_DEVICE_DISCONNECTED          8
#define BT_ERROR                        9
#define BT_MAX_SENSORS_REACHED         10
#define BT_DEVICE_ALREADY_CONNECTED    11
#define BT_DEVICE_NOT_FOUND            12
#define BT_PAIRING_FAILED              13
#define BT_DEVICE_FACTORY_RESETED      14
#define BT_SECURITY_CHANGE_FAILED      15
#define BT_TYPE_ERROR                  16
#define BT_MSGQ_ERROR                  17
#define BT_OTA_REQUEST                 18
#define BT_BLE_OTA_STARTED             20
#define BT_BLE_OTA_COMPLETED           21
#define BT_ERROR_LIST                  22
#define BT_BLEBLE_CLIENT_DATA          23
#define BT_BLEBLE_CLIENT_INFORMED      24
#define BT_BLEBLE_OTA_NEEDED           25
#define BT_CONNECTION_FAILED           26
#define BT_DISCOVERY_FAILURE           27
#define BT_ATTRIBUTE_WRITE_FAILURE     28
#define BT_MTU_UPDATE_FAILURE          29
#define BT_PHY_UPDATE_FAILURE          30
#define BT_BLEBLE_HOST_REBOOTED        31
#define BT_BLEBLE_OLD_CLIENT_DATA      32
#define BT_BLEBLE_CLIENT_OFFLINE       33
#define BT_BLEBLE_CLIENT_NEVER_SEEN    34
#define BT_BLEBLE_UNKNOWN_STATE        35


typedef struct {
    int peer_index;
    int status;
    const uint8_t* data;
    size_t data_len;
    int8_t rssi;
    uint8_t reason;
} ble_return_data_t;

typedef void (*ble_cb_t)(ble_return_data_t, const uint8_t*);

int ble_scanner_init(ble_cb_t ble_cb, bool settings);
int update_peer_target(uint8_t* addr, uint8_t* temp);
int update_peer_error_list(uint8_t* addr, uint8_t* errorlist, size_t len);
int set_factory_reset_request(uint8_t* addr);
int add_connectable_addr(uint8_t* addr);
int get_address(uint8_t* addr_buf);
int enqueue_peer_dfu(uint8_t* addr);
int bleble_assign_thermo(uint8_t* hostaddr, uint8_t* clientaddr);
int update_remote_error_indication_active(uint8_t* addr, bool active);

#endif /* BLE_SCANNER_NEW_H_ */
